#TEMPLATE (RebaseDLL, 'Rebase a DLL for better loading'),FAMILY('ABC','CW20')
#!===========================================================================
#!
#! Change History
#!  9/1/1 - split code that does the work into its own #GROUP to make it easier
#!             for developers to add the worker code to BuildExp directly
#!             and not have the extension template
#!  
#!===========================================================================
#EXTENSION (SetImageBase,'Set Image Base Address of Dll from INI'), APPLICATION, FIRST
#SHEET,ADJUST
  #TAB('Settings')
    #PROMPT('Rebase.INI File',OPENDIALOG('Choose Rebase.INI File','INI Files|*.INI|All Files|*.*')),%RebaseINI,DEFAULT('.\Rebase.INI'),REQ    
    #! Warning, the above OPENDIALOG( will return a file name w/o a path that will cause GETINI 
    #! to look in the windows directory. This is fixed up before using.   
    #BOXED('')
        #DISPLAY('Setting a Base Address for each DLL allows it')
        #DISPLAY('to be loaded faster by Windows and take less')
        #DISPLAY('page pool memory. It also writes the debug')
        #DISPLAY('MAP with the addresses at which the DLL will')
        #DISPLAY('actually be loaded. A DLL cannot be shared')
        #DISPLAY('unless it has a correct base address.')
        #DISPLAY('')
        #DISPLAY('This tempate adds a "IMAGE_BASE ####h" line to')
        #DISPLAY('the EXP file before the Exports section in the')
        #DISPLAY('embed point "Before the export list".')
        #DISPLAY('')         
        #DISPLAY('The ####h addresses are read from the ')
        #DISPLAY('Rebase.INI file. See the Rebase.INI Tab for more')   
        #DISPLAY('information.')
    #ENDBOXED
  #ENDTAB
  #TAB('Summary')
         #DISPLAY('Instructions:')
         #DISPLAY('1. Create the Rebase.INI file')
         #DISPLAY('2. Run your Program.EXE')        
         #DISPLAY('3. Run a Process Viewer and find your Program.EXE')
         #DISPLAY('4. Find each DLL of yours and note the size')
         #DISPLAY('5. In Rebase.INI [Rebase] add "AppName=BaseAddrH"')
         #DISPLAY('6. Recompile the App')
         #DISPLAY('7. AppName.EXP should have IMAGE_BASE BaseAddrH')
         #DISPLAY('')
         #DISPLAY('Also check on www.carlbarnes.com for the utility')
         #DISPLAY('named CarlBase.EXE that makes this easier.')
         #DISPLAY('')
  #ENDTAB
  #TAB('Rebase.INI')
         #DISPLAY('[Rebase]')
         #DISPLAY('AppName=address')        
         #DISPLAY('AppName1=05100000h')
         #DISPLAY('AppName2=05200000h')
         #DISPLAY('/NoWarn=1    Note: No warning if App is not in INI')
         #DISPLAY('')
         #DISPLAY('Addresses MUST BE in Hex and in 10000h increments')
         #DISPLAY('so just end addresses with 0000h.')        
         #DISPLAY('Allowed address ranges 05000000h-68F00000h.')                
         #DISPLAY('')
         #DISPLAY('Suggest:')        
         #DISPLAY('Put DLLs in the range 05000000h-0FF00000.')        
         #DISPLAY('100000h is 1MB so to put DLLs on 1MB')                
         #DISPLAY('increments end addresses with 00000.')
         #DISPLAY('Allow 1MB to 4MB per DLL.')        
         #DISPLAY('E.g.: 05000000, 05400000, 05800000')
         #DISPLAY('')
         #DISPLAY('Also check on www.carlbarnes.com for the utility')
         #DISPLAY('named CarlBase.EXE that makes this file for you.')
         #DISPLAY('')
  #ENDTAB
  #TAB('Process Viewers')
        #DISPLAY('To find load conflicts you will need view ')
        #DISPLAY('your running EXE in a process viewer.')
        #DISPLAY('')
        #DISPLAY('Dependency Walker is the best and free from')
        #DISPLAY('  www.DependencyWalker.com')
        #DISPLAY('')                
        #DISPLAY('Process Explorer is free from www.sysinternals.com')
        #DISPLAY('')
        #DISPLAY('Process Info is included with the Jeffery Richter book')
        #DISPLAY('  Programming Applications for MicroSoft Windows')
        #DISPLAY('  ISBN 1-57231-996-8')
        #DISPLAY('')
  #ENDTAB
#ENDSHEET
        #DISPLAY('Copyright (c)2001 Carl Barnes, Barrington Illinois')
        #DISPLAY('www.CarlBarnes.com - carl@carlbarnes.com')
        #DISPLAY('Free for the use of Clarion Magazine subscribers')

#! add a Why Rebase button
#! Faster Load, no relocating, less file reading
#! Less Page File Use, less memory use on start
#! Old pages can be throw out and reloaded from file
#! Rebased DLL cannot be shared so more memory use
#!----------
#AT(%BeforeExportList),WHERE(%Target32 AND %ProgramExtension='DLL')
    #DECLARE(%RebaseINI4GETINI)
    #IF (INSTRING('\',%RebaseINI,1))         #! GETINI needs a path or assumes C:\Windows
        #SET(%RebaseINI4GETINI,%RebaseINI)
    #ELSE
        #SET(%RebaseINI4GETINI,'.\' & %RebaseINI)  #! No path so
    #ENDIF                
#INSERT(%RebaseInsertExpLine, %RebaseINI4GETINI, 'Rebase'),NOINDENT
#ENDAT
#!==============================================================================
#! This group takes the RebaseINI file name so it can GETINI(Section,App,,Rebase.INI)
#! the Address from the INI, validate it and write the EXP line
#! 
#! This is a separate group so you can just add this #GROUP to BuildExp.TPW or ABBldExp.TPW
#! and not do the extension template. Then in #AT(%BeforeExportList) you need to 
#! add some logic like this to call it:
#!
#!      #INSERT(%RebaseInsertExpLine, 'd:\CW\Rebase\MasterRebase.ini','Rebase'),NOINDENT
#!
#! One enhancement would be to pass %DictionaryFile as the INI section (normally 'Rebase')
#! and have one big Rebase.INI file that is for all projects.
#!
#! Another enhancement would be to use Target name instead of App Name
#! #SET(%TargetWOExt,UPPER(SUB(%ProjectTarget,1,INSTRING('.',%ProjectTarget)-1)))
#!
#!----------------------------------------------------------------------------------
#GROUP(%RebaseInsertExpLine, STRING %GETINIFileName, STRING %GETINISection )
#IF (~%Target32 OR %ProgramExtension<>'DLL')    #! Only do this if its a 32-bit DLL
    #RETURN
#ENDIF
#!
#!------Prepare and get address from INI-------
#DECLARE(%ImageBaseAddr)
#DECLARE(%BaseAddrIsBad)
#SET(%ImageBaseAddr,UPPER(GETINI(%GETINISection,%Application,'',%GETINIFileName)))
#!------Test that we have a good address to avoid Linker error-------
#IF (%ImageBaseAddr)
    #IF (SUB(%ImageBaseAddr,-1,1)<>'H')      #! Must have h on End
        #SET(%ImageBaseAddr,%ImageBaseAddr & 'H')
    #ENDIF
    #IF (LEN(%ImageBaseAddr) < 9)            #! Zero pad the front to 8 hexdigits
        #SET(%ImageBaseAddr,ALL('0', 9-LEN(%ImageBaseAddr)) & %ImageBaseAddr )    
    #ENDIF
    #IF (LEN(%ImageBaseAddr) <> 9)  
        #SET(%BaseAddrIsBad,'Length must be 8 hexdigits')
    #ELSIF (~MATCH(%ImageBaseAddr,'^[0-9A-F]+H$', 12h ))    #! 12h=regex+nocase
        #SET(%BaseAddrIsBad,'Address must be in 8 hex digits 0-9,A-F')    
    #ELSIF (SUB(%ImageBaseAddr,5,5)<>'0000H')      #!address must be on 64KB or 10000h boundarys         
        #SET(%BaseAddrIsBad,'Address must end with 0000h, e.g. 400000h')    
    #ELSIF (SUB(%ImageBaseAddr,1,3)<'004')         #!00400000h is not allowed in Win9x, ok in NT but bad idea, use high addresses
        #SET(%BaseAddrIsBad,'Address must be 400000h or higher')    
    #ELSIF (SUB(%ImageBaseAddr,1,3)>'6FF')         #!70000000h and up is for O/S
        #SET(%BaseAddrIsBad,'Address must be less than 6FFF0000h')    
    #ENDIF
#ENDIF
#!------Output an error, or the Image Base line or a warning-------
#IF (%BaseAddrIsBad)
  ;--Rebase SetImageBase Template -- Address "%ImageBaseAddr" is invalid: %BaseAddrIsBad
      #ERROR('Rebase address "' & %ImageBaseAddr & '" is invalid: ' & %BaseAddrIsBad )
#ELSIF (%ImageBaseAddr)
IMAGE_BASE %ImageBaseAddr  ;--From Rebase SetImageBase Template -- %Application= in [Rebase] of "%GETINIFileName"
#ELSE 
  ;--Rebase SetImageBase Template -- "%Application=Address" NOT FOUND in [Rebase] of "%GETINIFileName"
  #IF (GETINI(%GETINISection,'/NoWarn','',%GETINIFileName)<>'1')
      #ERROR('Warning - Rebase address missing for "' & %Application & '" in "' & %GETINIFileName &'". DLL will base at default 40000h,  /NoWarn=1 to turn off warnings')
  #ENDIF
#ENDIF
#RETURN
#!
#! http://www.heaventools.com/index.htm#feat
#! PE Explorer - lets you look at the reloacation table and much more
#!                 disassembler, $70, 30-day trial
  #!     #PROMPT('Rebase.INI File',OPENDIALOG('Choose Rebase.INI File','INI Files|*.INI|All Files|*.*')),%RebaseINI,DEFAULT('.\Rebase.INI'),REQ    
  #!     #! Warning, the above OPENDIALOG( will return a file name w/o a path that will cause GETINI 
  #!     #! to look in the windows directory. This is fixed up before using.   
  #!     #BOXED('')
  #!         #DISPLAY('Adds "IMAGE_BASE ####h" to the AppName.EXP file.')
  #!         #DISPLAY('The addresses are read from the Rebase.INI file')
  #!         #DISPLAY('which has the format shown below')   
  #!         #DISPLAY('[Rebase]')
  #!         #DISPLAY('AppName1=54000000h     Note: h=Hex')
  #!         #DISPLAY('AppName2=56000000h')
  #!         #DISPLAY('/NoWarn=1    Note: No warning if App is not in INI')
  #!         #DISPLAY('')
  #!         #DISPLAY('Addresses MUST BE in Hex and in 10000h increments')
  #!         #DISPLAY('so just end addresses with 0000h.')        
  #!         #DISPLAY('Suggested address ranges 12000000h-68F00000h.')                
  #!         #DISPLAY('100000h is 1MB so to put DLLs on 1MB')                
  #!         #DISPLAY('increments end addresses with 00000.')
  #!         #DISPLAY('')        
  #!         #DISPLAY('Instructions:')
  #!         #DISPLAY('1. Create the Rebase.INI file named above')
  #!         #DISPLAY('2. Run your Program.EXE')        
  #!         #DISPLAY('3. Run a Process list and find your Program.EXE')
  #!         #DISPLAY('4. Find each DLL of yours and note the size')
  #!         #DISPLAY('5. In Rebase.INI [Rebase] add "AppName=BaseAddrH"')
  #!         #DISPLAY('6. Recompile the App')
  #!         #DISPLAY('7. AppName.EXP should have IMAGE_BASE BaseAddrH')
  #!     #ENDBOXED
  #!         #DISPLAY('(c)2001 Carl Barnes, Barrington Illinois')
  #!         #DISPLAY('www.CarlBarnes.com - carl@carlbarnes.com')                                

